{-# LANGUAGE BangPatterns #-}
module Simulation.Simulator where

import Simulation.Common()
import System.Random(RandomGen)
import Control.Monad.Random(Rand)

simulateUntil ::
	(RandomGen g) =>
	Int 				->	--Number of simulation steps
	a				->	--Initial model
	(a -> Rand g Bool)		->	--Function to check if simulation should end
	(Float -> a -> Rand g a)	-> 	--Update model one step
	Rand g a
simulateUntil !num !model !done !update = do
	!stop <- done model
	if stop then return model
	else do updateM <- update (1 / fromIntegral num) model
		simulateUntil num updateM done update
